Open CASCADE Technology: DrawTrSurf_BSplineSurface Class Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
DrawTrSurf_BSplineSurface Class Reference

This class defines a drawable BSplineSurface. With this class you can draw the control points and the knots of the surface. You can use the general class Surface from DrawTrSurf too, if you just want to sea boundaries and isoparametric curves. More...

`#include <DrawTrSurf_BSplineSurface.hxx>`

Inheritance diagram for DrawTrSurf_BSplineSurface:
[legend]

## Public Member Functions
| DrawTrSurf_BSplineSurface (const Handle< Geom_BSplineSurface > &S)
| default drawing mode. The isoparametric curves corresponding to the knots values are drawn. The control points and the knots points are drawn. The boundaries are yellow, the isoparametric curves are blues. For the discretisation 50 points are computed in each parametric direction. More...
| DrawTrSurf_BSplineSurface (const Handle< Geom_BSplineSurface > &S, const Draw_Color &BoundsColor, const Draw_Color &IsosColor, const Draw_Color &PolesColor, const Draw_Color &KnotsColor, const Draw_MarkerShape KnotsShape, const Standard_Integer KnotsSize, const Standard_Boolean ShowPoles, const Standard_Boolean ShowKnots, const Standard_Integer Discret, const Standard_Real Deflection, const Standard_Integer DrawMode)
| The isoparametric curves corresponding to the knots values are drawn. More...
| DrawTrSurf_BSplineSurface (const Handle< Geom_BSplineSurface > &S, const Standard_Integer NbUIsos, const Standard_Integer NbVIsos, const Draw_Color &BoundsColor, const Draw_Color &IsosColor, const Draw_Color &PolesColor, const Draw_Color &KnotsColor, const Draw_MarkerShape KnotsShape, const Standard_Integer KnotsSize, const Standard_Boolean ShowPoles, const Standard_Boolean ShowKnots, const Standard_Integer Discret, const Standard_Real Deflection, const Standard_Integer DrawMode)
| Parametric equidistant iso curves are drawn. More...
void | DrawOn (Draw_Display &dis) const
| this is defined only to tell C++ not to complain about inheriting a pure virtual method. More...
void | ShowPoles ()
void | ShowKnots ()
virtual void | ShowIsos (const Standard_Integer Nu, const Standard_Integer Nv)
| change the number of isoparametric curves to be drawn. More...
void | ShowKnotsIsos ()
| change the number of isoparametric curves to be drawn. More...
virtual void | ClearIsos ()
| rub out all the isoparametric curves. More...
void | ClearPoles ()
void | ClearKnots ()
void | FindPole (const Standard_Real X, const Standard_Real Y, const Draw_Display &D, const Standard_Real Prec, Standard_Integer &UIndex, Standard_Integer &VIndex) const
void | FindUKnot (const Standard_Real X, const Standard_Real Y, const Draw_Display &D, const Standard_Real Prec, Standard_Integer &UIndex) const
void | FindVKnot (const Standard_Real X, const Standard_Real Y, const Draw_Display &D, const Standard_Real Prec, Standard_Integer &VIndex) const
void | SetPolesColor (const Draw_Color &aColor)
void | SetKnotsColor (const Draw_Color &aColor)
void | SetKnotsShape (const Draw_MarkerShape Shape)
Draw_MarkerShape | KnotsShape () const
Draw_Color | KnotsColor () const
Draw_Color | PolesColor () const
virtual Handle< Draw_Drawable3D > | Copy () const
| For variable copy. More...
Public Member Functions inherited from DrawTrSurf_Surface
| DrawTrSurf_Surface (const Handle< Geom_Surface > &S)
| default drawing mode Just the middle isoparametric curves are drawn. The boundaries are yellow, the isoparametric curves are blues. For the discretisation 50 points are computed in each parametric direction. More...
| DrawTrSurf_Surface (const Handle< Geom_Surface > &S, const Standard_Integer Nu, const Standard_Integer Nv, const Draw_Color &BoundsColor, const Draw_Color &IsosColor, const Standard_Integer Discret, const Standard_Real Deflection, const Standard_Integer DrawMode)
Draw_Color | BoundsColor () const
void | DrawOn (Draw_Display &dis) const
| this is defined only to tell C++ not to complain about inheriting a pure virtual method. More...
void | DrawOn (Draw_Display &dis, const Standard_Boolean Iso) const
| Iso = True : Draw the isos, the boundaries, the UVMarker. Iso = False: Only Draw the boundary and the UVMarker. More...
Handle< Geom_Surface > | GetSurface () const
Draw_Color | IsosColor () const
void | NbIsos (Standard_Integer &Nu, Standard_Integer &Nb) const
void | SetBoundsColor (const Draw_Color &aColor)
void | SetIsosColor (const Draw_Color &aColor)
virtual void | Dump (Standard_OStream &S) const
| For variable dump. More...
virtual void | Whatis (Draw_Interpretor &I) const
| For variable whatis command. More...
Public Member Functions inherited from DrawTrSurf_Drawable
void | DrawCurve2dOn (Adaptor2d_Curve2d &C, Draw_Display &D) const
| Draw a polygon of the curve on the Display. More...
void | DrawCurveOn (Adaptor3d_Curve &C, Draw_Display &D) const
| Draw a polygon of the curve on the Display. More...
void | DrawIsoCurveOn (Adaptor3d_IsoCurve &C, const GeomAbs_IsoType T, const Standard_Real P, const Standard_Real F, const Standard_Real L, Draw_Display &D) const
| Load C with the specified iso and Draw a polygon of the curve on the Display. More...
void | SetDiscretisation (const Standard_Integer Discret)
Standard_Integer | GetDiscretisation () const
void | SetDeflection (const Standard_Real Deflection)
Standard_Real | GetDeflection () const
void | SetDrawMode (const Standard_Integer DrawMode)
Standard_Integer | GetDrawMode () const
Public Member Functions inherited from Draw_Drawable3D
virtual Standard_Boolean | PickReject (const Standard_Real X, const Standard_Real Y, const Standard_Real Prec) const
| Returs True if the pick is outside the box. More...
virtual Standard_Boolean | Is3D () const
| Is a 3D object. (Default True). More...
void | SetBounds (const Standard_Real xmin, const Standard_Real xmax, const Standard_Real ymin, const Standard_Real ymax)
void | Bounds (Standard_Real &xmin, Standard_Real &xmax, Standard_Real &ymin, Standard_Real &ymax) const
Standard_Boolean | Visible () const
void | Visible (const Standard_Boolean V)
Standard_Boolean | Protected () const
void | Protected (const Standard_Boolean P)
Standard_CString | Name () const
virtual void | Name (const Standard_CString N)
Public Member Functions inherited from MMgt_TShared
virtual void | Delete () const
| Memory deallocator for transient classes. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Additional Inherited Members
Protected Member Functions inherited from DrawTrSurf_Drawable
| DrawTrSurf_Drawable (const Standard_Integer discret, const Standard_Real deflection=0.01, const Standard_Integer DrawMode=0)
| set the number of points on a curve at creation. More...
Protected Member Functions inherited from Draw_Drawable3D
| Draw_Drawable3D ()
Protected Attributes inherited from DrawTrSurf_Surface
Handle< Geom_Surface > | surf
Draw_Color | boundsLook
Draw_Color | isosLook
Standard_Integer | nbUIsos
Standard_Integer | nbVIsos

## Detailed Description

This class defines a drawable BSplineSurface. With this class you can draw the control points and the knots of the surface. You can use the general class Surface from DrawTrSurf too, if you just want to sea boundaries and isoparametric curves.

## Constructor & Destructor Documentation

DrawTrSurf_BSplineSurface::DrawTrSurf_BSplineSurface | ( | const Handle< Geom_BSplineSurface > & | S | ) |

default drawing mode. The isoparametric curves corresponding to the knots values are drawn. The control points and the knots points are drawn. The boundaries are yellow, the isoparametric curves are blues. For the discretisation 50 points are computed in each parametric direction.

DrawTrSurf_BSplineSurface::DrawTrSurf_BSplineSurface | ( | const Handle< Geom_BSplineSurface > & | S,
|  | const Draw_Color & | BoundsColor,
|  | const Draw_Color & | IsosColor,
|  | const Draw_Color & | PolesColor,
|  | const Draw_Color & | KnotsColor,
|  | const Draw_MarkerShape | KnotsShape,
|  | const Standard_Integer | KnotsSize,
|  | const Standard_Boolean | ShowPoles,
|  | const Standard_Boolean | ShowKnots,
|  | const Standard_Integer | Discret,
|  | const Standard_Real | Deflection,
|  | const Standard_Integer | DrawMode
| ) |  |

The isoparametric curves corresponding to the knots values are drawn.

DrawTrSurf_BSplineSurface::DrawTrSurf_BSplineSurface | ( | const Handle< Geom_BSplineSurface > & | S,
|  | const Standard_Integer | NbUIsos,
|  | const Standard_Integer | NbVIsos,
|  | const Draw_Color & | BoundsColor,
|  | const Draw_Color & | IsosColor,
|  | const Draw_Color & | PolesColor,
|  | const Draw_Color & | KnotsColor,
|  | const Draw_MarkerShape | KnotsShape,
|  | const Standard_Integer | KnotsSize,
|  | const Standard_Boolean | ShowPoles,
|  | const Standard_Boolean | ShowKnots,
|  | const Standard_Integer | Discret,
|  | const Standard_Real | Deflection,
|  | const Standard_Integer | DrawMode
| ) |  |

Parametric equidistant iso curves are drawn.

## Member Function Documentation

virtual void DrawTrSurf_BSplineSurface::ClearIsos | ( |  | ) |
| virtual

rub out all the isoparametric curves.

Reimplemented from DrawTrSurf_Surface.

void DrawTrSurf_BSplineSurface::ClearKnots | ( |  | ) |

void DrawTrSurf_BSplineSurface::ClearPoles | ( |  | ) |

virtual Handle< Draw_Drawable3D > DrawTrSurf_BSplineSurface::Copy | ( |  | ) | const
| virtual

For variable copy.

Reimplemented from DrawTrSurf_Surface.

void DrawTrSurf_BSplineSurface::DrawOn | ( | Draw_Display & | dis | ) | const
| virtual

this is defined only to tell C++ not to complain about inheriting a pure virtual method.

Implements DrawTrSurf_Drawable.

void DrawTrSurf_BSplineSurface::FindPole | ( | const Standard_Real | X,
|  | const Standard_Real | Y,
|  | const Draw_Display & | D,
|  | const Standard_Real | Prec,
|  | Standard_Integer & | UIndex,
|  | Standard_Integer & | VIndex
| ) |  | const

void DrawTrSurf_BSplineSurface::FindUKnot | ( | const Standard_Real | X,
|  | const Standard_Real | Y,
|  | const Draw_Display & | D,
|  | const Standard_Real | Prec,
|  | Standard_Integer & | UIndex
| ) |  | const

void DrawTrSurf_BSplineSurface::FindVKnot | ( | const Standard_Real | X,
|  | const Standard_Real | Y,
|  | const Draw_Display & | D,
|  | const Standard_Real | Prec,
|  | Standard_Integer & | VIndex
| ) |  | const

Draw_Color DrawTrSurf_BSplineSurface::KnotsColor | ( |  | ) | const

Draw_MarkerShape DrawTrSurf_BSplineSurface::KnotsShape | ( |  | ) | const

Draw_Color DrawTrSurf_BSplineSurface::PolesColor | ( |  | ) | const

void DrawTrSurf_BSplineSurface::SetKnotsColor | ( | const Draw_Color & | aColor | ) |

void DrawTrSurf_BSplineSurface::SetKnotsShape | ( | const Draw_MarkerShape | Shape | ) |

void DrawTrSurf_BSplineSurface::SetPolesColor | ( | const Draw_Color & | aColor | ) |

virtual void DrawTrSurf_BSplineSurface::ShowIsos | ( | const Standard_Integer | Nu,
|  | const Standard_Integer | Nv
| ) |  |
| virtual

change the number of isoparametric curves to be drawn.

Reimplemented from DrawTrSurf_Surface.

void DrawTrSurf_BSplineSurface::ShowKnots | ( |  | ) |

void DrawTrSurf_BSplineSurface::ShowKnotsIsos | ( |  | ) |

change the number of isoparametric curves to be drawn.

void DrawTrSurf_BSplineSurface::ShowPoles | ( |  | ) |

The documentation for this class was generated from the following file:

- DrawTrSurf_BSplineSurface.hxx